<?php
/**
 * OOPでBBS (Step4)
 *
 * オブジェクト指向プログラミングで掲示板を作ってみる。
 * ブログでその作り方を晒すために書いたものです。
 * 詳しい事は当該記事を見てください。 
 *
 *
 *           
 * PHP version 5.3
 *
 * LICENSE : このソースはCreative Commons 表示 - 非営利 2.1 日本 Licenseです。
 *           改変は自由ですが営利目的で利用することは出来ません。
 * 
 * @category  Step4
 * @package   OOP-BBS
 * @author    Tenderfeel <tenderfeel@gmail.com>
 * @copyright Copyright (c) 2010 Tenderfeel.(http://webtecnote.com)
 * @license   http://creativecommons.org/licenses/by-nc/2.1/jp/
 * @since     File available since Release 1.0.0 (step1)
 *
 */
 

/**
 * 掲示板をコントロールするクラス
 *
 * ModelとViewの中間に立って仕事を振り分けます。
 * ユーザが起こしたイベントに対して応答し、色々と処理します。
 * 仕分け人なので描画やデータの操作は行いません。
 *
 * <step4>
 * Modelから受け取った掲示板のログをViewに渡す。
 * 
 * @author    Tenderfeel <tenderfeel@gmail.com>
 * @copyright Copyright (c) 2010 Tenderfeel.(http://webtecnote.com)
 * @license   Creative Commons BY-NC http://creativecommons.org/licenses/by-nc/2.1/jp/
 * @since     File available since Release 1.0.0 (step1)
 */

class Controller {
    
    public function __construct()
    {
    }
    
    /**
     * index.phpから実行されるメソッド
     * @return {}
     * @since 1.0 (step1)
     */
    public function execute()
    {
        

        include_once('model.php');
        include_once('view.php');
        include_once('bbs_log.php');
        
        $modelInstance = new Model();//モデル
        $viewInstance = new View();//ビュー
        
        $message = '';
        
        $viewInstance->setTemplateName('index');//テンプレートをセット
        $modelInstance->setLogfileName('bbslog');//ログファイルをセット
        
        if(isset($_POST['mode']) && $_POST['mode'] != ''){
            
            switch($_POST['mode']){
                
                case 'write':
        
                    $modelInstance->setPostdata($_POST);//送信内容のセット
            
                    if($modelInstance->validation()===true){
                        $modelInstance->write();//ログに書き込み
                        $viewInstance->setSystemMessage('保存しました');//メッセージをセット
                        
                    }else{
                        $viewInstance->setErrorMessage($modelInstance->getError());//エラーをビューに渡す
                    }
            
                break;
                
                default:
                    
            }
            
        }
        
        $modelInstance->readLog();//ログを読み込む
        $viewInstance->setLog($modelInstance->getLogData());//Viewに渡す
        
        $viewInstance->display();//表示
    
    }
}

?>